#include <stdio.h>
#include <time.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include "mt64.h"
#include "land.h"
#include "landscapetobit.h"
static unsigned long long seed ;
/*
#define x_size  200
#define y_size  200
*/

 int * createlandscape2d(int x_size, int y_size)
{
	// this creates the pointer to the array landscape, calloc allocates the size of array on the memory for the whole programm until it is freed
	int *landscape = calloc(y_size*x_size,y_size*x_size);
	// this sets all the values in the array to zero
	memset(landscape, 0, sizeof(landscape));
	printf("Your landscape of x = %d  and y = %d was successfully created.\n It is still empty. \n", x_size, y_size);
	// this returns the pointer to the array 
	return landscape;

}


int * inilandscapesingle(int x_size, int y_size, int *ptom)
{
	// this makes landscape the pointer to the array pointed at by ptom
	int *landscape = ptom;
	// this line creates a single cell at the middle of the lattice 
	landscape[((y_size*x_size)/2)+ (x_size /2)]  = 1;
	printf("Your landscape was successfully initialize with a single cell in the middle of the landscape\n");
	return landscape;
}
int * inilandscapesingle2(int x_size, int y_size, int *ptom)
{
	int *landscape = ptom;
	landscape[((y_size*x_size)/2)+ (x_size /2)]  = 1;
	landscape[((y_size*x_size)/2)+ (x_size /2)+4]  = 2;
	printf("Your landscape was successfully initialize with a single cell in the middle of the landscape\n");
	createfrommatrix( x_size, y_size, 0, 255, 0, landscape, "afterini.bmp");
	return landscape;
}
int * inilandscaperandom(int x_size, int y_size,int *ptom, double occupancy, long long seed)
{
	int *landscape = ptom;
	// this intializes the Mersenne twister random function 
	init_genrand64(seed);
	int j =  0;
	// this is the loop that goes through the whole lattice 
	while (j < x_size*y_size)
	{
		// this line generates a random real between 0 and 1
		double r = genrand64_real2();
		// Here if this condition is verified the position in the array is filled with a 1
		if (r < occupancy) 
		{
			landscape[j] = 1;
			j++;
		}
		else 
		{
			j++;
		} 

	}
	printf("Your landscape was successfully inintialized randomly with occupancy rate equal to %f \n",occupancy);
	return landscape;
}

int * inilandscaperandom2(int x_size, int y_size,int *ptom, double occupancy, long long seed)
{
	int *landscape = ptom;

	int j =  0;
	while (j < x_size*y_size)
	{
		double r = genrand64_real2();
		double c = genrand64_real2();
		if (r < occupancy && c < 0.5) 
		{
			landscape[j] = 1;
			j++;
		}
		else if(r < occupancy && c > 0.5)
		{
			landscape[j] = 2;
			j++;
		}
		else 
		{
			j++;
		} 

	}
	createfrommatrix( x_size, y_size, 0, 255, 0, landscape, "randomfirst.bmp");
	printf("Your landscape was successfully inintialized randomly with occupancy rate equal to %f of two organisms \n",occupancy);
	return landscape;
}

int * randomwalk(int x_size, int y_size,int *ptom,  double survival, long long seed)
{
	int *landscape = ptom;
	init_genrand64(seed);
	int sites = 0;
	int size  = y_size * x_size;
	int randomx = 0;
	int neighbour = 0;
	for (sites  = 0; sites < size; sites ++)
	{
		randomx = (int) floor((genrand64_real2()*size));
		switch(landscape[randomx])
		{
			case 0:
				switch((int) ceil(genrand64_real3()*4))
				{
					case 1:
						neighbour = landscape[((randomx - 1)%x_size) + (randomx/y_size)*y_size];
						break;
					case 2:
						neighbour = landscape[((randomx + 1)%x_size) + (randomx / y_size)*y_size];
						break;
					case 3:
						if (randomx-x_size < 0)
						{
							neighbour = landscape[((randomx/x_size - 1)*-1)%y_size * x_size + randomx%x_size];
						break;
						}
						else
						{
							neighbour = landscape[(((randomx/x_size) - 1)%y_size) * x_size + randomx%x_size];
							break;
						}
					case 4:
						neighbour = landscape[((randomx/x_size + 1)%y_size) * x_size + randomx%x_size];
						break;
				}
				if (neighbour ==1)
				{
					landscape[randomx] = 1;
				}
				break;
			case 1:
				if (genrand64_real2() < survival)
				{
					//printf("survived\n");	
					landscape[randomx] = 0;
				}
				break;


		} 

	}
	return landscape;
}

int * randomwalk2(int x_size, int y_size,int *ptom,  double survival, long long seed)
{
	int *landscape = ptom;
	init_genrand64(seed);
	int sites = 0;
	int size  = y_size * x_size;
	int randomx = 0;
	int neighbour = 0;
	// a loop running for total nuber of sites
	for (sites  = 0; sites < size; sites ++)
	{
		// creating a random number that will be the site of interest
		randomx = (int) floor((genrand64_real2()*size));
		// switch is like an if except faster in c so here it returns the value of site randomx
		switch(landscape[randomx])
		{
			case 0:
				// choosing one of four neighbours of site randomx at random
				switch((int) ceil(genrand64_real3()*4))
				{
					//Picking the neighbour on the right 
					case 1:
						neighbour = landscape[(randomx+1)%x_size + (randomx/x_size)*x_size];
						break;
					
					//Picking the neighbour on the left
					case 2:
						if (randomx-1 < 0)
						{
							neighbour = landscape[x_size-1];
							break;
						}
						else
						{
							neighbour = landscape[(randomx-1)%x_size + (randomx/x_size)*x_size];
							break;
						}
					
					// Picking the southern neighbour 
					case 3:
						neighbour = landscape[(randomx + x_size)%(x_size*y_size)];
						break;

					//Picking the northen neighbour 
					case 4:
						if (randomx-x_size < 0)
						{
							neighbour = landscape[randomx+x_size*(y_size-1)];
							break;
						}
						else
						{
							neighbour = landscape[randomx-x_size];	
							break;
						}
						
				}
				if (neighbour ==1)
				{
					landscape[randomx] = 1;
				}
				break;
			case 1:
				// computing if an occupied site should die or not depending on death rate 
				if (genrand64_real2() < survival)
				{	
					landscape[randomx] = 0;
				}
				break;
		} 

	}
	return landscape;
}
int runsimulationbmp(int x_size, int y_size,int *ptom, int timeofsim, double survival, long long seed)
{
	init_genrand64(seed);
	int i = 0;
	char name[11] = "";
	while (i < timeofsim)
	{
		sprintf(name,"images/simu%d.bmp",(i+200));
		ptom = randomwalk2( x_size, y_size, ptom, survival, genrand64_int63());
		createfrommatrix( x_size, y_size, 0, 255, 0, ptom, name);
		i++;
	}
	printf("Your simulation ran for time %d is finished and bmp files were created\n",timeofsim );
	void free(void * ptom); 
	return 0;
}
